#coui-project



 需要先安装依赖

```bash
# npm 安装
npm i

# 或者可以用cnpm 安装，可以加快安装速度
cnpm i
```

###开发：
```bash
# 执行如下命令后访问 localhost:8080
npm run dev
```

###编译：
```bash
# 会在项目目录下自动生成 build 目录
npm run build

# 会在项目目录下自动生成 dist 目录，经过混淆压缩后可以发布的版本
npm run dist
```

###发布：
```bash
# 编译源码并压缩上传到 xSimple 平台（模块名称与 xSimple 后台模块配置标识对应）
# 将混淆代码到 dist 目录，并生成zip压缩文件到 zip 目录
npm run publish
```



## 项目结构

构建后项目结构为
```text
|- bin/  ---------------------------- 脚本工具
|- config/  ------------------------- 脚本配置
|- src/  ---------------------------- 项目源代码(每个文件夹自动对应一个模块，文件夹名称就对应模块名称)
    |- example-base/  --------------- 基础demo示例
        |- index.vue  --------------- 模块首页页面
        |- index.js  ---------------- 模块入口文件
    |- example-light  --------------- 轻量demo示例(包含组件、页面切换、调用接口、原生能力等)
    |- example-native/  ------------- 所有原生能力示例
    |- example-redirect/  ----------- 页面跳转示例
    |- example-components/  --------- 所有组件示例
    |- coui-public/  --------------------- 公共模块文件
        |- components/  ------------- 项目共用组件
        |- config/  ----------------- 全局配置文件
        |- js/  --------------------- 共用js
        |- less/  ------------------- 模块化组件样式
        |- store/  ------------------ 全局通用store
    |- App.vue----------------------- vue根组件    
|- build/  -------------------------- 项目build目录(build后自动生成)
|- dist/  --------------------------- 项目dist目录(dist后自动生成)
|- zip/  ---------------------------- 项目zip包目录(zip后自动生成)
|- index.html  ---------------------- HTML 模板
|- package.json  -------------------- npm 配置文件
|- README.md  ----------------------- 项目帮助文档
|- gulpfile.js  --------------------- gulp脚本
```



## 配置

config/service.js 配置模块上传xsimple地址
