require('./check-versions')();
process.env.NODE_ENV = process.env.NODE_ENV || 'production';

var ora = require('ora');
var chalk = require('chalk');
var webpack = require('webpack');
// var config = require('../config');
var webpackConfig = {};

var spinner = ora('building for production...');
spinner.start();

webpackConfig = require('./webpack.prod.conf');
webpack(webpackConfig, function(err, stats2) {
  spinner.stop();
  if (err) {
    throw err;
  }
  process.stdout.write(stats2.toString({
    colors: true,
    modules: false,
    children: false,
    chunks: false,
    chunkModules: false
  }) + '\n');
  console.log(chalk.cyan('  Build complete.\n'));
  console.log(chalk.yellow(
    '  Tip: built files are meant to be served over an HTTP server.\n' +
    '  Opening index.html over file:// won\'t work.\n'
  ));
});
