let fs = require('fs')
  , inquirer = require('inquirer')
  , ora = require('ora')
  , cmd = require('child_process')

  , args = JSON.parse(process.env.npm_config_argv).original || process.argv
  , mode = args[1]
  , modes = { 'dist': 'dist', 'build': 'build', 'publish': 'dist' }
  , index = args.findIndex(a => a === '-m') + 1
  , modules = index ? args[index] : []
  // Build multiple modules
  , buildModules = answers => {
    let ms = answers.modules.join(',')
      , spinner = ora(`running ${mode} for product ==> ${ms}`)
      ;
    if (ms.length) {
      spinner.start();
      cmd.exec(`npm run ${modes[mode]}:runner -m ${ms}`, function(err, stdout, stderr){
        if (err) {
          console.error(err);
        } else {
          if (mode === 'publish') {
            cmd.exec(`gulp upload -m ${ms}`, function(err, stdout, stderr) {
              if (err) {
                console.error(err);
              }
            });
          }
          spinner.stop();
        }
      });
    } else {
      throw console.error('没有选择编译模块');
    }
  };

  if (modules.length) {
    modules = modules.split(',');
    // IDE input
    buildModules({modules: modules});
  } else {
    modules = fs.readdirSync('./src').filter(name => name.indexOf('.') === -1)
    // User choices
    inquirer.prompt([{
      type: 'checkbox',
      name: 'modules',
      message: '选择要编译的模块 < 全选(a)/反选(i) >:',
      choices: modules,
      default: []
    }]).then(function (answers) {
      // Choices result
      buildModules(answers);
    });
  }
