'use strict';
var webpack = require('webpack');
var path = require('path');
var config = require('../config');
var utils = require('./utils');
var baseWebpackConfig = require('./webpack.base.conf');
var source = config.common.assetsSourcePath;
var publicSource= config.common.assetsPublicSourcePath;

module.exports = {
  entry: config.build.library,
  output: {
    path: source,
    filename: utils.assetsPath('dll/[name].dll.js'),
    library: '[name]_library'
  },
  resolve: baseWebpackConfig.resolve,
  module: {
    rules: [
      ...baseWebpackConfig.module.rules,
      ...utils.styleLoaders({
        sourceMap: config.dist.productionSourceMap,
        extract: false
      })
    ]
  },
  plugins: [
    new webpack.DllPlugin({
      path: `${publicSource}/dll/[name].dll.manifest.json`,
      name: '[name]_library'
    }),
    new webpack.optimize.UglifyJsPlugin({
      minimize: true,
      output: {comments: false},
      uglifyOptions: {
        compress: {
          warnings: false
        }
      },
      sourceMap: config.dist.productionSourceMap,
      parallel: true
    })
  ]
};
