// see http://vuejs-templates.github.io/webpack for documentation.
var path = require('path')
var library = require('./library')

function resolve(dir) {
  return path.join(__dirname, '..', dir);
}

module.exports = {
  common: {
    assetsSourcePath: resolve('src'),
    assetsPublicSourcePath: resolve('src/coui-public'),
    assetsComponentsSourcePath: resolve('src/coui-public/components'),
    assetsDevRoot: resolve('resource'),
    publicDirectory: 'coui-public'
  },
  build: {
    env: require('./dev.env'),
    index: resolve('build/index.html'),
    assetsRoot: resolve('build'),
    assetsSubDirectory: 'coui-public',
    assetsPublicPath: '/',
    productionSourceMap: true,
    // Gzip off by default as many popular static hosts such as
    // Surge or Netlify already gzip all static assets for you.
    // Before setting to `true`, make sure to:
    // npm install --save-dev compression-webpack-plugin
    productionGzip: false,
    productionGzipExtensions: ['js', 'css'],
    // Run the build command with an extra argument to
    // View the bundle analyzer report after build finishes:
    // `npm run build --report`
    // Set to `true` or `false` to always turn it on or off
    bundleAnalyzerReport: process.env.npm_config_report,
    // Set to clean output dir or not
    cleanOutputDir: false,
    // Dll library
    library: library
  },
  dist: {
    env: require('./prod.env'),
    index: resolve('dist/index.html'),
    assetsRoot: resolve('dist'),
    assetsSubDirectory: 'coui-public',
    assetsPublicPath: '/',
    productionSourceMap: false,
    // Gzip off by default as many popular static hosts such as
    // Surge or Netlify already gzip all static assets for you.
    // Before setting to `true`, make sure to:
    // npm install --save-dev compression-webpack-plugin
    productionGzip: false,
    productionGzipExtensions: ['js', 'css'],
    // Run the build command with an extra argument to
    // View the bundle analyzer report after build finishes:
    // `npm run build --report`
    // Set to `true` or `false` to always turn it on or off
    bundleAnalyzerReport: process.env.npm_config_report,
    // Set to clean output dir or not
    cleanOutputDir: false
  },
  dev: {
    env: require('./dev.env'),
    port: 8080,
    autoOpenBrowser: true,
    assetsRoot: resolve('static'),
    assetsSubDirectory: 'coui-public',
    assetsPublicPath: '/',
    proxyTable: {},
    productionSourceMap: false,
    // CSS Sourcemaps off by default because relative paths are "buggy"
    // with this option, according to the CSS-Loader README
    // (https://github.com/webpack/css-loader#sourcemaps)
    // In our experience, they generally work as expected,
    // just be aware of this issue when enabling this option.
    cssSourceMap: false
  }
}
