/**
 * @author umin <326663876@qq.com>, caixue, yangjianfeng, tangjian
 * @since
 * @copyright Copyright (c) 2018, YZKJ
 * @description 全局注入
 */
import Vue from 'vue';
import CoUI from 'coui';
import 'CoUI/src/style/base.css';
import 'CoUI/lib/style.css';
import fallback from 'components/cus-fallback';
import empty from 'components/cus-empty';
import cusImg from 'components/cus-img';
import cusPicker from 'components/cus-picker';
import cusLoading from 'components/cus-loading';
import cusCascader from 'components/cus-cascader';

// Global Event Controller
class Event {
  constructor() {
    corJS.out('Event register', 'public');
    this.event = new Vue();
  };
  on() {
    this.event.$on(...arguments);
  };
  off() {
    this.event.$off(...arguments);
  };
  once() {
    this.event.$once(...arguments);
  };
  emit() {
    this.event.$emit(...arguments);
  };
};

// Inject CoUI
Vue.use(CoUI);

// Global GUI Tools
let cor = window.Cor;
cor.$messagebox = Vue.$messagebox;
cor.$toast = Vue.$toast;
cor.$indicator = Vue.$indicator;
cor.$event = new Event();

// Global component
Vue.component('fallback', fallback);
Vue.component('empty', empty);
Vue.component('cus-img', cusImg);
Vue.component('cus-picker', cusPicker);
Vue.component('cus-loading', cusLoading);
Vue.component('cus-cascader', cusCascader);
