/**
 * @file
 * @author IceFour
 * @date 18/5/3
 */

import {APIS} from 'api';
// 获取组织
export const getWorkOrg = ({state, commit}, id) => {
  console.log(id);
  return new Promise((resolve, reject) => {
    // 缓存数据，不重复请求接口获取
    if (state.workOrg.length > 0) {
      resolve();
      return;
    }
    var getData = {
      url: APIS.getWorkOrg,
      data: {
        jsonparm: JSON.stringify({p: 0, s: 10, id: ''})
      },
      method: 'post',
      // TODO: 封装数据处理fn
      cb: function(response, error) {
        if (error) {
          reject(error);
        }
        console.log(response);
        // status,data,errorMsg. data才是接口返回的数据
        if (response.status) { // 请求成功
          response = response.data;
          commit('updateWorkOrg', response.list);
          resolve();
        } else { // 请求失败 or 请求超时
          console.log(response.errorMessage);
        }
      }
    };
    // window.corNative.requestAjax(getData, getData.cb);
    window.corMPortal.requestProxy(getData, getData.cb);
  });
};

// 获取产品纬度
export const getNewsList = ({ state, commit }, obj) => {
  return new Promise((resolve, reject) => {
    // 缓存数据，不重复请求接口获取
    if (state.newsList.length) {
      resolve();
      return;
    }
    console.log(APIS.getNewsList);
    var getData = {
      url: APIS.getNewsList,
      data: { 'p': 0, 'title': '', 's': '10', 'newsCategoryId': 1 },
      method: 'post',
      // TODO: 封装数据处理fn
      cb: function(error, response) {
        if (error) {
          reject(error);
        }
        console.log(response);
        // status,data,errorMsg. data才是接口返回的数据
        response = response.data;
        if (response.status) { // 请求成功
          commit('updateNewsList', response.list);
          resolve();
        } else { // 请求失败 or 请求超时
          console.log(response.errorMessage);
        }
      }
    };
    console.log(getData);
    // window.corNative.requestAjax(getData, getData.cb);
    window.corMPortal.requestProxy(getData, getData.cb);
  });
};

/*
* 初始化数据任务列表
* @param <String>  type 查询任务类型：W 待处理  C 己完成  M 我发起  S 抄送我
* */
export const getTaskList = ({state, commit}, type) => {
  console.log(type);
  return new Promise((resolve, reject) => {
    var getData = {
      url: APIS.getTaskList,
      data: {
        jsonparm: JSON.stringify({
          taskStatus: type,
          p: 0,
          s: 10,
          keyWord: ''
        })
      },
      method: 'post',
      // TODO: 封装数据处理fn
      cb: function(error, response) {
        if (error === 1) {
          reject(error);
        }
        console.log(response);
        // status,data,errorMsg. data才是接口返回的数据
        if (error === 0) { // 请求成功
          response = response.data;
          commit('updateTaskList', {
            list: response.list,
            type: type
          });
          resolve();
        } else { // 请求失败 or 请求超时
          console.log(response.errorMessage);
        }
      }
    };
    // window.corNative.requestAjax(getData, getData.cb);
    window.corMPortal.requestProxy(getData, getData.cb);
  });
};
