/**
 * @author xxx
 * @since
 * @copyright Copyright (c) 2018, YZKJ
 * @description main 示例1
 */
import Vue from 'vue';
import VueRouter from 'vue-router';
import Vuex from 'vuex';
import App from '../App.vue';
import store from './store';
import routeJson from './route.json';

Vue.use(VueRouter);
Vue.use(Vuex);

let routes = [];
routeJson.map(nav =>
  nav.list.map((page) => {
    routes.push({
      name: page.name,
      path: page.path,
      component: require('./page' + page.path),
      meta: {
        title: page.title || page.name,
        description: page.description
      }
    });
  })
);

routes.push({
  name: 'index',
  path: '/',
  component: require('./page/index.vue')
});

const router = new VueRouter({
  base: __dirname,
  routes,
  scrollBehavior(to, from, savedPosition) {
    return typeof savedPosition === 'object' ? savedPosition : { x: 0, y: 0 };
  }
});

corJS.ready(function() { // eslint-disable-line
  new Vue({ // eslint-disable-line
    el: '#app',
    render: h => h(App),
    router,
    store: new Vuex.Store(store)
  });
});
