/**
 * @author umin 326663876@qq.com
 * @since 2018/08/01
 * @copyright Copyright (c) 2018, YZKJ
 * @description main 示例1
 */
import Vue from 'vue';
import VueRouter from 'vue-router';
import Vuex from 'vuex';
import App from '../App.vue';
import store from './store';
import routeJson from './route.json';

Vue.use(VueRouter);
Vue.use(Vuex);

// 路由配置
const router = new VueRouter({
  base: __dirname,
  routes: routeJson.page.map((page) => {
    return {
      name: page.name,
      path: page.path,
      component: require('./page/' + page.component)
    };
  }),
  scrollBehavior(to, from, savedPosition) {
    return typeof savedPosition === 'object' ? savedPosition : { x: 0, y: 0 };
  }
});

new Vue({ // eslint-disable-line
  el: '#app',
  render: h => h(App),
  router,
  store: new Vuex.Store(store)
});
