/**
 * @author xxx
 * @since
 * @copyright Copyright (c) 2018, YZKJ
 * @description store
 */
import Vue from 'vue';
import VueRouter from 'vue-router';
import Vuex from 'vuex';
import App from '../App.vue';
import store from './store';
import routeJson from './route.json';

Vue.use(VueRouter);
Vue.use(Vuex);

let routes = [];
routeJson.map(nav => {
  nav.list.map((page) => {
    routes.push({
      name: page.name,
      path: page.path,
      component: require('./page' + page.path)
    });
  });
  routes.push({
    name: nav.title,
    path: nav.path,
    component: require(`./page${nav.path}`)
  });
});

routes.push({
  name: 'index',
  path: '/',
  component: require('./page/index.vue')
});

const router = new VueRouter({
  base: __dirname,
  routes
});

corJS.ready(function() { // eslint-disable-line
  new Vue({ // eslint-disable-line
    el: '#app',
    render: h => h(App),
    router,
    store: new Vuex.Store(store)
  });
});

